// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dbw_fca_msgs:msg/BrakeInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__BUILDER_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dbw_fca_msgs/msg/detail/brake_info_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dbw_fca_msgs
{

namespace msg
{

namespace builder
{

class Init_BrakeInfoReport_stationary
{
public:
  explicit Init_BrakeInfoReport_stationary(::dbw_fca_msgs::msg::BrakeInfoReport & msg)
  : msg_(msg)
  {}
  ::dbw_fca_msgs::msg::BrakeInfoReport stationary(::dbw_fca_msgs::msg::BrakeInfoReport::_stationary_type arg)
  {
    msg_.stationary = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

class Init_BrakeInfoReport_brake_pressure
{
public:
  explicit Init_BrakeInfoReport_brake_pressure(::dbw_fca_msgs::msg::BrakeInfoReport & msg)
  : msg_(msg)
  {}
  Init_BrakeInfoReport_stationary brake_pressure(::dbw_fca_msgs::msg::BrakeInfoReport::_brake_pressure_type arg)
  {
    msg_.brake_pressure = std::move(arg);
    return Init_BrakeInfoReport_stationary(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

class Init_BrakeInfoReport_brake_torque_actual
{
public:
  explicit Init_BrakeInfoReport_brake_torque_actual(::dbw_fca_msgs::msg::BrakeInfoReport & msg)
  : msg_(msg)
  {}
  Init_BrakeInfoReport_brake_pressure brake_torque_actual(::dbw_fca_msgs::msg::BrakeInfoReport::_brake_torque_actual_type arg)
  {
    msg_.brake_torque_actual = std::move(arg);
    return Init_BrakeInfoReport_brake_pressure(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

class Init_BrakeInfoReport_brake_torque_request
{
public:
  explicit Init_BrakeInfoReport_brake_torque_request(::dbw_fca_msgs::msg::BrakeInfoReport & msg)
  : msg_(msg)
  {}
  Init_BrakeInfoReport_brake_torque_actual brake_torque_request(::dbw_fca_msgs::msg::BrakeInfoReport::_brake_torque_request_type arg)
  {
    msg_.brake_torque_request = std::move(arg);
    return Init_BrakeInfoReport_brake_torque_actual(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

class Init_BrakeInfoReport_brake_pc
{
public:
  explicit Init_BrakeInfoReport_brake_pc(::dbw_fca_msgs::msg::BrakeInfoReport & msg)
  : msg_(msg)
  {}
  Init_BrakeInfoReport_brake_torque_request brake_pc(::dbw_fca_msgs::msg::BrakeInfoReport::_brake_pc_type arg)
  {
    msg_.brake_pc = std::move(arg);
    return Init_BrakeInfoReport_brake_torque_request(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

class Init_BrakeInfoReport_header
{
public:
  Init_BrakeInfoReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_BrakeInfoReport_brake_pc header(::dbw_fca_msgs::msg::BrakeInfoReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_BrakeInfoReport_brake_pc(msg_);
  }

private:
  ::dbw_fca_msgs::msg::BrakeInfoReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dbw_fca_msgs::msg::BrakeInfoReport>()
{
  return dbw_fca_msgs::msg::builder::Init_BrakeInfoReport_header();
}

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__BUILDER_HPP_
