// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/HighBeam.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__HIGH_BEAM__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__HIGH_BEAM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__HighBeam __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__HighBeam __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HighBeam_
{
  using Type = HighBeam_<ContainerAllocator>;

  explicit HighBeam_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit HighBeam_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t IDLE =
    0u;
  static constexpr uint8_t HIBM_FLASH_ON =
    1u;
  static constexpr uint8_t HIBM_ON =
    2u;

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__HighBeam
    std::shared_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__HighBeam
    std::shared_ptr<dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HighBeam_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const HighBeam_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HighBeam_

// alias to use template instance with default allocator
using HighBeam =
  dbw_fca_msgs::msg::HighBeam_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t HighBeam_<ContainerAllocator>::IDLE;
template<typename ContainerAllocator>
constexpr uint8_t HighBeam_<ContainerAllocator>::HIBM_FLASH_ON;
template<typename ContainerAllocator>
constexpr uint8_t HighBeam_<ContainerAllocator>::HIBM_ON;

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__HIGH_BEAM__STRUCT_HPP_
