// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/HvacButtonCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__HVAC_BUTTON_CMD__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__HVAC_BUTTON_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__HvacButtonCmd __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__HvacButtonCmd __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HvacButtonCmd_
{
  using Type = HvacButtonCmd_<ContainerAllocator>;

  explicit HvacButtonCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd = 0;
    }
  }

  explicit HvacButtonCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _cmd_type =
    uint8_t;
  _cmd_type cmd;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__cmd(
    const uint8_t & _arg)
  {
    this->cmd = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NONE =
    0u;
  static constexpr uint8_t OFF =
    1u;
  static constexpr uint8_t ON =
    2u;

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__HvacButtonCmd
    std::shared_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__HvacButtonCmd
    std::shared_ptr<dbw_fca_msgs::msg::HvacButtonCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HvacButtonCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->cmd != other.cmd) {
      return false;
    }
    return true;
  }
  bool operator!=(const HvacButtonCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HvacButtonCmd_

// alias to use template instance with default allocator
using HvacButtonCmd =
  dbw_fca_msgs::msg::HvacButtonCmd_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t HvacButtonCmd_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t HvacButtonCmd_<ContainerAllocator>::OFF;
template<typename ContainerAllocator>
constexpr uint8_t HvacButtonCmd_<ContainerAllocator>::ON;

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__HVAC_BUTTON_CMD__STRUCT_HPP_
