// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/Ignition.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/ignition__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
dbw_fca_msgs__msg__Ignition__init(dbw_fca_msgs__msg__Ignition * msg)
{
  if (!msg) {
    return false;
  }
  // value
  return true;
}

void
dbw_fca_msgs__msg__Ignition__fini(dbw_fca_msgs__msg__Ignition * msg)
{
  if (!msg) {
    return;
  }
  // value
}

bool
dbw_fca_msgs__msg__Ignition__are_equal(const dbw_fca_msgs__msg__Ignition * lhs, const dbw_fca_msgs__msg__Ignition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // value
  if (lhs->value != rhs->value) {
    return false;
  }
  return true;
}

bool
dbw_fca_msgs__msg__Ignition__copy(
  const dbw_fca_msgs__msg__Ignition * input,
  dbw_fca_msgs__msg__Ignition * output)
{
  if (!input || !output) {
    return false;
  }
  // value
  output->value = input->value;
  return true;
}

dbw_fca_msgs__msg__Ignition *
dbw_fca_msgs__msg__Ignition__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__Ignition * msg = (dbw_fca_msgs__msg__Ignition *)allocator.allocate(sizeof(dbw_fca_msgs__msg__Ignition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__Ignition));
  bool success = dbw_fca_msgs__msg__Ignition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__Ignition__destroy(dbw_fca_msgs__msg__Ignition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dbw_fca_msgs__msg__Ignition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dbw_fca_msgs__msg__Ignition__Sequence__init(dbw_fca_msgs__msg__Ignition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__Ignition * data = NULL;

  if (size) {
    data = (dbw_fca_msgs__msg__Ignition *)allocator.zero_allocate(size, sizeof(dbw_fca_msgs__msg__Ignition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__Ignition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__Ignition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__Ignition__Sequence__fini(dbw_fca_msgs__msg__Ignition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__Ignition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__Ignition__Sequence *
dbw_fca_msgs__msg__Ignition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__Ignition__Sequence * array = (dbw_fca_msgs__msg__Ignition__Sequence *)allocator.allocate(sizeof(dbw_fca_msgs__msg__Ignition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__Ignition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__Ignition__Sequence__destroy(dbw_fca_msgs__msg__Ignition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dbw_fca_msgs__msg__Ignition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dbw_fca_msgs__msg__Ignition__Sequence__are_equal(const dbw_fca_msgs__msg__Ignition__Sequence * lhs, const dbw_fca_msgs__msg__Ignition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dbw_fca_msgs__msg__Ignition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dbw_fca_msgs__msg__Ignition__Sequence__copy(
  const dbw_fca_msgs__msg__Ignition__Sequence * input,
  dbw_fca_msgs__msg__Ignition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dbw_fca_msgs__msg__Ignition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dbw_fca_msgs__msg__Ignition * data =
      (dbw_fca_msgs__msg__Ignition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dbw_fca_msgs__msg__Ignition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dbw_fca_msgs__msg__Ignition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dbw_fca_msgs__msg__Ignition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
