// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/Misc1Report.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'turn_signal'
#include "dbw_fca_msgs/msg/detail/turn_signal__struct.hpp"
// Member 'high_beam'
#include "dbw_fca_msgs/msg/detail/high_beam__struct.hpp"
// Member 'wiper'
#include "dbw_fca_msgs/msg/detail/wiper__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__Misc1Report __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__Misc1Report __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Misc1Report_
{
  using Type = Misc1Report_<ContainerAllocator>;

  explicit Misc1Report_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    turn_signal(_init),
    high_beam(_init),
    wiper(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_cc_on_off = false;
      this->btn_cc_res = false;
      this->btn_cc_cncl = false;
      this->btn_cc_set_inc = false;
      this->btn_cc_set_dec = false;
      this->btn_cc_gap_inc = false;
      this->btn_cc_gap_dec = false;
      this->btn_cc_mode = false;
      this->btn_ld_ok = false;
      this->btn_ld_up = false;
      this->btn_ld_down = false;
      this->btn_ld_left = false;
      this->btn_ld_right = false;
      this->fault_bus = false;
      this->door_rear_left = false;
      this->door_rear_right = false;
      this->door_trunk = false;
    }
  }

  explicit Misc1Report_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    turn_signal(_alloc, _init),
    high_beam(_alloc, _init),
    wiper(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_cc_on_off = false;
      this->btn_cc_res = false;
      this->btn_cc_cncl = false;
      this->btn_cc_set_inc = false;
      this->btn_cc_set_dec = false;
      this->btn_cc_gap_inc = false;
      this->btn_cc_gap_dec = false;
      this->btn_cc_mode = false;
      this->btn_ld_ok = false;
      this->btn_ld_up = false;
      this->btn_ld_down = false;
      this->btn_ld_left = false;
      this->btn_ld_right = false;
      this->fault_bus = false;
      this->door_rear_left = false;
      this->door_rear_right = false;
      this->door_trunk = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _turn_signal_type =
    dbw_fca_msgs::msg::TurnSignal_<ContainerAllocator>;
  _turn_signal_type turn_signal;
  using _high_beam_type =
    dbw_fca_msgs::msg::HighBeam_<ContainerAllocator>;
  _high_beam_type high_beam;
  using _wiper_type =
    dbw_fca_msgs::msg::Wiper_<ContainerAllocator>;
  _wiper_type wiper;
  using _btn_cc_on_off_type =
    bool;
  _btn_cc_on_off_type btn_cc_on_off;
  using _btn_cc_res_type =
    bool;
  _btn_cc_res_type btn_cc_res;
  using _btn_cc_cncl_type =
    bool;
  _btn_cc_cncl_type btn_cc_cncl;
  using _btn_cc_set_inc_type =
    bool;
  _btn_cc_set_inc_type btn_cc_set_inc;
  using _btn_cc_set_dec_type =
    bool;
  _btn_cc_set_dec_type btn_cc_set_dec;
  using _btn_cc_gap_inc_type =
    bool;
  _btn_cc_gap_inc_type btn_cc_gap_inc;
  using _btn_cc_gap_dec_type =
    bool;
  _btn_cc_gap_dec_type btn_cc_gap_dec;
  using _btn_cc_mode_type =
    bool;
  _btn_cc_mode_type btn_cc_mode;
  using _btn_ld_ok_type =
    bool;
  _btn_ld_ok_type btn_ld_ok;
  using _btn_ld_up_type =
    bool;
  _btn_ld_up_type btn_ld_up;
  using _btn_ld_down_type =
    bool;
  _btn_ld_down_type btn_ld_down;
  using _btn_ld_left_type =
    bool;
  _btn_ld_left_type btn_ld_left;
  using _btn_ld_right_type =
    bool;
  _btn_ld_right_type btn_ld_right;
  using _fault_bus_type =
    bool;
  _fault_bus_type fault_bus;
  using _door_rear_left_type =
    bool;
  _door_rear_left_type door_rear_left;
  using _door_rear_right_type =
    bool;
  _door_rear_right_type door_rear_right;
  using _door_trunk_type =
    bool;
  _door_trunk_type door_trunk;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__turn_signal(
    const dbw_fca_msgs::msg::TurnSignal_<ContainerAllocator> & _arg)
  {
    this->turn_signal = _arg;
    return *this;
  }
  Type & set__high_beam(
    const dbw_fca_msgs::msg::HighBeam_<ContainerAllocator> & _arg)
  {
    this->high_beam = _arg;
    return *this;
  }
  Type & set__wiper(
    const dbw_fca_msgs::msg::Wiper_<ContainerAllocator> & _arg)
  {
    this->wiper = _arg;
    return *this;
  }
  Type & set__btn_cc_on_off(
    const bool & _arg)
  {
    this->btn_cc_on_off = _arg;
    return *this;
  }
  Type & set__btn_cc_res(
    const bool & _arg)
  {
    this->btn_cc_res = _arg;
    return *this;
  }
  Type & set__btn_cc_cncl(
    const bool & _arg)
  {
    this->btn_cc_cncl = _arg;
    return *this;
  }
  Type & set__btn_cc_set_inc(
    const bool & _arg)
  {
    this->btn_cc_set_inc = _arg;
    return *this;
  }
  Type & set__btn_cc_set_dec(
    const bool & _arg)
  {
    this->btn_cc_set_dec = _arg;
    return *this;
  }
  Type & set__btn_cc_gap_inc(
    const bool & _arg)
  {
    this->btn_cc_gap_inc = _arg;
    return *this;
  }
  Type & set__btn_cc_gap_dec(
    const bool & _arg)
  {
    this->btn_cc_gap_dec = _arg;
    return *this;
  }
  Type & set__btn_cc_mode(
    const bool & _arg)
  {
    this->btn_cc_mode = _arg;
    return *this;
  }
  Type & set__btn_ld_ok(
    const bool & _arg)
  {
    this->btn_ld_ok = _arg;
    return *this;
  }
  Type & set__btn_ld_up(
    const bool & _arg)
  {
    this->btn_ld_up = _arg;
    return *this;
  }
  Type & set__btn_ld_down(
    const bool & _arg)
  {
    this->btn_ld_down = _arg;
    return *this;
  }
  Type & set__btn_ld_left(
    const bool & _arg)
  {
    this->btn_ld_left = _arg;
    return *this;
  }
  Type & set__btn_ld_right(
    const bool & _arg)
  {
    this->btn_ld_right = _arg;
    return *this;
  }
  Type & set__fault_bus(
    const bool & _arg)
  {
    this->fault_bus = _arg;
    return *this;
  }
  Type & set__door_rear_left(
    const bool & _arg)
  {
    this->door_rear_left = _arg;
    return *this;
  }
  Type & set__door_rear_right(
    const bool & _arg)
  {
    this->door_rear_right = _arg;
    return *this;
  }
  Type & set__door_trunk(
    const bool & _arg)
  {
    this->door_trunk = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__Misc1Report
    std::shared_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__Misc1Report
    std::shared_ptr<dbw_fca_msgs::msg::Misc1Report_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Misc1Report_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->turn_signal != other.turn_signal) {
      return false;
    }
    if (this->high_beam != other.high_beam) {
      return false;
    }
    if (this->wiper != other.wiper) {
      return false;
    }
    if (this->btn_cc_on_off != other.btn_cc_on_off) {
      return false;
    }
    if (this->btn_cc_res != other.btn_cc_res) {
      return false;
    }
    if (this->btn_cc_cncl != other.btn_cc_cncl) {
      return false;
    }
    if (this->btn_cc_set_inc != other.btn_cc_set_inc) {
      return false;
    }
    if (this->btn_cc_set_dec != other.btn_cc_set_dec) {
      return false;
    }
    if (this->btn_cc_gap_inc != other.btn_cc_gap_inc) {
      return false;
    }
    if (this->btn_cc_gap_dec != other.btn_cc_gap_dec) {
      return false;
    }
    if (this->btn_cc_mode != other.btn_cc_mode) {
      return false;
    }
    if (this->btn_ld_ok != other.btn_ld_ok) {
      return false;
    }
    if (this->btn_ld_up != other.btn_ld_up) {
      return false;
    }
    if (this->btn_ld_down != other.btn_ld_down) {
      return false;
    }
    if (this->btn_ld_left != other.btn_ld_left) {
      return false;
    }
    if (this->btn_ld_right != other.btn_ld_right) {
      return false;
    }
    if (this->fault_bus != other.fault_bus) {
      return false;
    }
    if (this->door_rear_left != other.door_rear_left) {
      return false;
    }
    if (this->door_rear_right != other.door_rear_right) {
      return false;
    }
    if (this->door_trunk != other.door_trunk) {
      return false;
    }
    return true;
  }
  bool operator!=(const Misc1Report_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Misc1Report_

// alias to use template instance with default allocator
using Misc1Report =
  dbw_fca_msgs::msg::Misc1Report_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_HPP_
