// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/Misc2Report.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'ft_drv_temp'
// Member 'ft_psg_temp'
#include "dbw_fca_msgs/msg/detail/front_temp__struct.h"
// Member 'ft_fan_speed'
#include "dbw_fca_msgs/msg/detail/front_fan_speed__struct.h"
// Member 'vent_mode'
#include "dbw_fca_msgs/msg/detail/vent_mode__struct.h"
// Member 'fl_heated_seat'
// Member 'fl_vented_seat'
// Member 'fr_heated_seat'
// Member 'fr_vented_seat'
#include "dbw_fca_msgs/msg/detail/hvac_seat__struct.h"

/// Struct defined in msg/Misc2Report in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__Misc2Report
{
  std_msgs__msg__Header header;
  /// Front Driver Temperature Status
  dbw_fca_msgs__msg__FrontTemp ft_drv_temp;
  /// Front Passenger Temperature Status
  dbw_fca_msgs__msg__FrontTemp ft_psg_temp;
  /// Front Fan Speed Status
  dbw_fca_msgs__msg__FrontFanSpeed ft_fan_speed;
  /// Front Button Status
  bool max_ac;
  bool ac;
  bool ft_hvac;
  bool auto_md;
  bool recirc;
  bool sync;
  bool r_defr;
  bool f_defr;
  /// Vent Mode Status
  dbw_fca_msgs__msg__VentMode vent_mode;
  /// Heated Steering Wheel Status
  bool heated_steering_wheel;
  /// Front Left Heated Seat Status
  dbw_fca_msgs__msg__HvacSeat fl_heated_seat;
  /// Front Left Vented Seat Status
  dbw_fca_msgs__msg__HvacSeat fl_vented_seat;
  /// Front Right Heated Seat Status
  dbw_fca_msgs__msg__HvacSeat fr_heated_seat;
  /// Front Right Vented Seat Status
  dbw_fca_msgs__msg__HvacSeat fr_vented_seat;
} dbw_fca_msgs__msg__Misc2Report;

// Struct for a sequence of dbw_fca_msgs__msg__Misc2Report.
typedef struct dbw_fca_msgs__msg__Misc2Report__Sequence
{
  dbw_fca_msgs__msg__Misc2Report * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__Misc2Report__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_H_
