// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dbw_fca_msgs:msg/Misc2Report.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__TRAITS_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dbw_fca_msgs/msg/detail/misc2_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'ft_drv_temp'
// Member 'ft_psg_temp'
#include "dbw_fca_msgs/msg/detail/front_temp__traits.hpp"
// Member 'ft_fan_speed'
#include "dbw_fca_msgs/msg/detail/front_fan_speed__traits.hpp"
// Member 'vent_mode'
#include "dbw_fca_msgs/msg/detail/vent_mode__traits.hpp"
// Member 'fl_heated_seat'
// Member 'fl_vented_seat'
// Member 'fr_heated_seat'
// Member 'fr_vented_seat'
#include "dbw_fca_msgs/msg/detail/hvac_seat__traits.hpp"

namespace dbw_fca_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Misc2Report & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: ft_drv_temp
  {
    out << "ft_drv_temp: ";
    to_flow_style_yaml(msg.ft_drv_temp, out);
    out << ", ";
  }

  // member: ft_psg_temp
  {
    out << "ft_psg_temp: ";
    to_flow_style_yaml(msg.ft_psg_temp, out);
    out << ", ";
  }

  // member: ft_fan_speed
  {
    out << "ft_fan_speed: ";
    to_flow_style_yaml(msg.ft_fan_speed, out);
    out << ", ";
  }

  // member: max_ac
  {
    out << "max_ac: ";
    rosidl_generator_traits::value_to_yaml(msg.max_ac, out);
    out << ", ";
  }

  // member: ac
  {
    out << "ac: ";
    rosidl_generator_traits::value_to_yaml(msg.ac, out);
    out << ", ";
  }

  // member: ft_hvac
  {
    out << "ft_hvac: ";
    rosidl_generator_traits::value_to_yaml(msg.ft_hvac, out);
    out << ", ";
  }

  // member: auto_md
  {
    out << "auto_md: ";
    rosidl_generator_traits::value_to_yaml(msg.auto_md, out);
    out << ", ";
  }

  // member: recirc
  {
    out << "recirc: ";
    rosidl_generator_traits::value_to_yaml(msg.recirc, out);
    out << ", ";
  }

  // member: sync
  {
    out << "sync: ";
    rosidl_generator_traits::value_to_yaml(msg.sync, out);
    out << ", ";
  }

  // member: r_defr
  {
    out << "r_defr: ";
    rosidl_generator_traits::value_to_yaml(msg.r_defr, out);
    out << ", ";
  }

  // member: f_defr
  {
    out << "f_defr: ";
    rosidl_generator_traits::value_to_yaml(msg.f_defr, out);
    out << ", ";
  }

  // member: vent_mode
  {
    out << "vent_mode: ";
    to_flow_style_yaml(msg.vent_mode, out);
    out << ", ";
  }

  // member: heated_steering_wheel
  {
    out << "heated_steering_wheel: ";
    rosidl_generator_traits::value_to_yaml(msg.heated_steering_wheel, out);
    out << ", ";
  }

  // member: fl_heated_seat
  {
    out << "fl_heated_seat: ";
    to_flow_style_yaml(msg.fl_heated_seat, out);
    out << ", ";
  }

  // member: fl_vented_seat
  {
    out << "fl_vented_seat: ";
    to_flow_style_yaml(msg.fl_vented_seat, out);
    out << ", ";
  }

  // member: fr_heated_seat
  {
    out << "fr_heated_seat: ";
    to_flow_style_yaml(msg.fr_heated_seat, out);
    out << ", ";
  }

  // member: fr_vented_seat
  {
    out << "fr_vented_seat: ";
    to_flow_style_yaml(msg.fr_vented_seat, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Misc2Report & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: ft_drv_temp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ft_drv_temp:\n";
    to_block_style_yaml(msg.ft_drv_temp, out, indentation + 2);
  }

  // member: ft_psg_temp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ft_psg_temp:\n";
    to_block_style_yaml(msg.ft_psg_temp, out, indentation + 2);
  }

  // member: ft_fan_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ft_fan_speed:\n";
    to_block_style_yaml(msg.ft_fan_speed, out, indentation + 2);
  }

  // member: max_ac
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_ac: ";
    rosidl_generator_traits::value_to_yaml(msg.max_ac, out);
    out << "\n";
  }

  // member: ac
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ac: ";
    rosidl_generator_traits::value_to_yaml(msg.ac, out);
    out << "\n";
  }

  // member: ft_hvac
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ft_hvac: ";
    rosidl_generator_traits::value_to_yaml(msg.ft_hvac, out);
    out << "\n";
  }

  // member: auto_md
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "auto_md: ";
    rosidl_generator_traits::value_to_yaml(msg.auto_md, out);
    out << "\n";
  }

  // member: recirc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recirc: ";
    rosidl_generator_traits::value_to_yaml(msg.recirc, out);
    out << "\n";
  }

  // member: sync
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sync: ";
    rosidl_generator_traits::value_to_yaml(msg.sync, out);
    out << "\n";
  }

  // member: r_defr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "r_defr: ";
    rosidl_generator_traits::value_to_yaml(msg.r_defr, out);
    out << "\n";
  }

  // member: f_defr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "f_defr: ";
    rosidl_generator_traits::value_to_yaml(msg.f_defr, out);
    out << "\n";
  }

  // member: vent_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vent_mode:\n";
    to_block_style_yaml(msg.vent_mode, out, indentation + 2);
  }

  // member: heated_steering_wheel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heated_steering_wheel: ";
    rosidl_generator_traits::value_to_yaml(msg.heated_steering_wheel, out);
    out << "\n";
  }

  // member: fl_heated_seat
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fl_heated_seat:\n";
    to_block_style_yaml(msg.fl_heated_seat, out, indentation + 2);
  }

  // member: fl_vented_seat
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fl_vented_seat:\n";
    to_block_style_yaml(msg.fl_vented_seat, out, indentation + 2);
  }

  // member: fr_heated_seat
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fr_heated_seat:\n";
    to_block_style_yaml(msg.fr_heated_seat, out, indentation + 2);
  }

  // member: fr_vented_seat
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fr_vented_seat:\n";
    to_block_style_yaml(msg.fr_vented_seat, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Misc2Report & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dbw_fca_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dbw_fca_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dbw_fca_msgs::msg::Misc2Report & msg,
  std::ostream & out, size_t indentation = 0)
{
  dbw_fca_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dbw_fca_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dbw_fca_msgs::msg::Misc2Report & msg)
{
  return dbw_fca_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dbw_fca_msgs::msg::Misc2Report>()
{
  return "dbw_fca_msgs::msg::Misc2Report";
}

template<>
inline const char * name<dbw_fca_msgs::msg::Misc2Report>()
{
  return "dbw_fca_msgs/msg/Misc2Report";
}

template<>
struct has_fixed_size<dbw_fca_msgs::msg::Misc2Report>
  : std::integral_constant<bool, has_fixed_size<dbw_fca_msgs::msg::FrontFanSpeed>::value && has_fixed_size<dbw_fca_msgs::msg::FrontTemp>::value && has_fixed_size<dbw_fca_msgs::msg::HvacSeat>::value && has_fixed_size<dbw_fca_msgs::msg::VentMode>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dbw_fca_msgs::msg::Misc2Report>
  : std::integral_constant<bool, has_bounded_size<dbw_fca_msgs::msg::FrontFanSpeed>::value && has_bounded_size<dbw_fca_msgs::msg::FrontTemp>::value && has_bounded_size<dbw_fca_msgs::msg::HvacSeat>::value && has_bounded_size<dbw_fca_msgs::msg::VentMode>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dbw_fca_msgs::msg::Misc2Report>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__TRAITS_HPP_
