// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dbw_fca_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__BUILDER_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dbw_fca_msgs/msg/detail/misc_cmd__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dbw_fca_msgs
{

namespace msg
{

namespace builder
{

class Init_MiscCmd_fr_vented_seat
{
public:
  explicit Init_MiscCmd_fr_vented_seat(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  ::dbw_fca_msgs::msg::MiscCmd fr_vented_seat(::dbw_fca_msgs::msg::MiscCmd::_fr_vented_seat_type arg)
  {
    msg_.fr_vented_seat = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_fr_heated_seat
{
public:
  explicit Init_MiscCmd_fr_heated_seat(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_fr_vented_seat fr_heated_seat(::dbw_fca_msgs::msg::MiscCmd::_fr_heated_seat_type arg)
  {
    msg_.fr_heated_seat = std::move(arg);
    return Init_MiscCmd_fr_vented_seat(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_fl_vented_seat
{
public:
  explicit Init_MiscCmd_fl_vented_seat(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_fr_heated_seat fl_vented_seat(::dbw_fca_msgs::msg::MiscCmd::_fl_vented_seat_type arg)
  {
    msg_.fl_vented_seat = std::move(arg);
    return Init_MiscCmd_fr_heated_seat(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_fl_heated_seat
{
public:
  explicit Init_MiscCmd_fl_heated_seat(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_fl_vented_seat fl_heated_seat(::dbw_fca_msgs::msg::MiscCmd::_fl_heated_seat_type arg)
  {
    msg_.fl_heated_seat = std::move(arg);
    return Init_MiscCmd_fl_vented_seat(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_heated_steering_wheel
{
public:
  explicit Init_MiscCmd_heated_steering_wheel(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_fl_heated_seat heated_steering_wheel(::dbw_fca_msgs::msg::MiscCmd::_heated_steering_wheel_type arg)
  {
    msg_.heated_steering_wheel = std::move(arg);
    return Init_MiscCmd_fl_heated_seat(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_vent_mode
{
public:
  explicit Init_MiscCmd_vent_mode(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_heated_steering_wheel vent_mode(::dbw_fca_msgs::msg::MiscCmd::_vent_mode_type arg)
  {
    msg_.vent_mode = std::move(arg);
    return Init_MiscCmd_heated_steering_wheel(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_f_defr
{
public:
  explicit Init_MiscCmd_f_defr(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_vent_mode f_defr(::dbw_fca_msgs::msg::MiscCmd::_f_defr_type arg)
  {
    msg_.f_defr = std::move(arg);
    return Init_MiscCmd_vent_mode(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_r_defr
{
public:
  explicit Init_MiscCmd_r_defr(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_f_defr r_defr(::dbw_fca_msgs::msg::MiscCmd::_r_defr_type arg)
  {
    msg_.r_defr = std::move(arg);
    return Init_MiscCmd_f_defr(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_sync
{
public:
  explicit Init_MiscCmd_sync(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_r_defr sync(::dbw_fca_msgs::msg::MiscCmd::_sync_type arg)
  {
    msg_.sync = std::move(arg);
    return Init_MiscCmd_r_defr(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_recirc
{
public:
  explicit Init_MiscCmd_recirc(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_sync recirc(::dbw_fca_msgs::msg::MiscCmd::_recirc_type arg)
  {
    msg_.recirc = std::move(arg);
    return Init_MiscCmd_sync(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_auto_md
{
public:
  explicit Init_MiscCmd_auto_md(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_recirc auto_md(::dbw_fca_msgs::msg::MiscCmd::_auto_md_type arg)
  {
    msg_.auto_md = std::move(arg);
    return Init_MiscCmd_recirc(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_ft_hvac
{
public:
  explicit Init_MiscCmd_ft_hvac(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_auto_md ft_hvac(::dbw_fca_msgs::msg::MiscCmd::_ft_hvac_type arg)
  {
    msg_.ft_hvac = std::move(arg);
    return Init_MiscCmd_auto_md(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_ac
{
public:
  explicit Init_MiscCmd_ac(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_ft_hvac ac(::dbw_fca_msgs::msg::MiscCmd::_ac_type arg)
  {
    msg_.ac = std::move(arg);
    return Init_MiscCmd_ft_hvac(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_max_ac
{
public:
  explicit Init_MiscCmd_max_ac(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_ac max_ac(::dbw_fca_msgs::msg::MiscCmd::_max_ac_type arg)
  {
    msg_.max_ac = std::move(arg);
    return Init_MiscCmd_ac(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_ft_fan_speed
{
public:
  explicit Init_MiscCmd_ft_fan_speed(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_max_ac ft_fan_speed(::dbw_fca_msgs::msg::MiscCmd::_ft_fan_speed_type arg)
  {
    msg_.ft_fan_speed = std::move(arg);
    return Init_MiscCmd_max_ac(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_ft_psg_temp
{
public:
  explicit Init_MiscCmd_ft_psg_temp(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_ft_fan_speed ft_psg_temp(::dbw_fca_msgs::msg::MiscCmd::_ft_psg_temp_type arg)
  {
    msg_.ft_psg_temp = std::move(arg);
    return Init_MiscCmd_ft_fan_speed(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_ft_drv_temp
{
public:
  explicit Init_MiscCmd_ft_drv_temp(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_ft_psg_temp ft_drv_temp(::dbw_fca_msgs::msg::MiscCmd::_ft_drv_temp_type arg)
  {
    msg_.ft_drv_temp = std::move(arg);
    return Init_MiscCmd_ft_psg_temp(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_door
{
public:
  explicit Init_MiscCmd_door(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_ft_drv_temp door(::dbw_fca_msgs::msg::MiscCmd::_door_type arg)
  {
    msg_.door = std::move(arg);
    return Init_MiscCmd_ft_drv_temp(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_cmd
{
public:
  explicit Init_MiscCmd_cmd(::dbw_fca_msgs::msg::MiscCmd & msg)
  : msg_(msg)
  {}
  Init_MiscCmd_door cmd(::dbw_fca_msgs::msg::MiscCmd::_cmd_type arg)
  {
    msg_.cmd = std::move(arg);
    return Init_MiscCmd_door(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

class Init_MiscCmd_header
{
public:
  Init_MiscCmd_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MiscCmd_cmd header(::dbw_fca_msgs::msg::MiscCmd::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_MiscCmd_cmd(msg_);
  }

private:
  ::dbw_fca_msgs::msg::MiscCmd msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dbw_fca_msgs::msg::MiscCmd>()
{
  return dbw_fca_msgs::msg::builder::Init_MiscCmd_header();
}

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__BUILDER_HPP_
