// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/ThrottleInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'gear_num'
#include "dbw_fca_msgs/msg/detail/gear_num__struct.hpp"
// Member 'ignition'
#include "dbw_fca_msgs/msg/detail/ignition__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__ThrottleInfoReport __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__ThrottleInfoReport __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ThrottleInfoReport_
{
  using Type = ThrottleInfoReport_<ContainerAllocator>;

  explicit ThrottleInfoReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    gear_num(_init),
    ignition(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->throttle_pc = 0.0f;
      this->axle_torque = 0.0f;
    }
  }

  explicit ThrottleInfoReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    gear_num(_alloc, _init),
    ignition(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->throttle_pc = 0.0f;
      this->axle_torque = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _throttle_pc_type =
    float;
  _throttle_pc_type throttle_pc;
  using _axle_torque_type =
    float;
  _axle_torque_type axle_torque;
  using _gear_num_type =
    dbw_fca_msgs::msg::GearNum_<ContainerAllocator>;
  _gear_num_type gear_num;
  using _ignition_type =
    dbw_fca_msgs::msg::Ignition_<ContainerAllocator>;
  _ignition_type ignition;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__throttle_pc(
    const float & _arg)
  {
    this->throttle_pc = _arg;
    return *this;
  }
  Type & set__axle_torque(
    const float & _arg)
  {
    this->axle_torque = _arg;
    return *this;
  }
  Type & set__gear_num(
    const dbw_fca_msgs::msg::GearNum_<ContainerAllocator> & _arg)
  {
    this->gear_num = _arg;
    return *this;
  }
  Type & set__ignition(
    const dbw_fca_msgs::msg::Ignition_<ContainerAllocator> & _arg)
  {
    this->ignition = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__ThrottleInfoReport
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__ThrottleInfoReport
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleInfoReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ThrottleInfoReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->throttle_pc != other.throttle_pc) {
      return false;
    }
    if (this->axle_torque != other.axle_torque) {
      return false;
    }
    if (this->gear_num != other.gear_num) {
      return false;
    }
    if (this->ignition != other.ignition) {
      return false;
    }
    return true;
  }
  bool operator!=(const ThrottleInfoReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ThrottleInfoReport_

// alias to use template instance with default allocator
using ThrottleInfoReport =
  dbw_fca_msgs::msg::ThrottleInfoReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_HPP_
