// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/Wiper.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__WIPER__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__WIPER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__Wiper __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__Wiper __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Wiper_
{
  using Type = Wiper_<ContainerAllocator>;

  explicit Wiper_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit Wiper_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    uint8_t;
  _status_type status;

  // setters for named parameter idiom
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t OFF =
    0u;
  static constexpr uint8_t MANUAL_ON =
    4u;
  static constexpr uint8_t MANUAL_LOW =
    5u;
  static constexpr uint8_t MANUAL_HIGH =
    6u;
  static constexpr uint8_t MIST_FLICK =
    7u;
  static constexpr uint8_t WASH =
    8u;
  static constexpr uint8_t FLT =
    14u;

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::Wiper_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::Wiper_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Wiper_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Wiper_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__Wiper
    std::shared_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__Wiper
    std::shared_ptr<dbw_fca_msgs::msg::Wiper_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Wiper_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const Wiper_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Wiper_

// alias to use template instance with default allocator
using Wiper =
  dbw_fca_msgs::msg::Wiper_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::OFF;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::MANUAL_ON;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::MANUAL_LOW;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::MANUAL_HIGH;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::MIST_FLICK;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::WASH;
template<typename ContainerAllocator>
constexpr uint8_t Wiper_<ContainerAllocator>::FLT;

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__WIPER__STRUCT_HPP_
