// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/BrakeInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__BrakeInfoReport __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__BrakeInfoReport __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BrakeInfoReport_
{
  using Type = BrakeInfoReport_<ContainerAllocator>;

  explicit BrakeInfoReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_pc = 0.0f;
      this->brake_torque_request = 0.0f;
      this->brake_torque_actual = 0.0f;
      this->brake_pressure = 0.0f;
      this->stationary = false;
    }
  }

  explicit BrakeInfoReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_pc = 0.0f;
      this->brake_torque_request = 0.0f;
      this->brake_torque_actual = 0.0f;
      this->brake_pressure = 0.0f;
      this->stationary = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _brake_pc_type =
    float;
  _brake_pc_type brake_pc;
  using _brake_torque_request_type =
    float;
  _brake_torque_request_type brake_torque_request;
  using _brake_torque_actual_type =
    float;
  _brake_torque_actual_type brake_torque_actual;
  using _brake_pressure_type =
    float;
  _brake_pressure_type brake_pressure;
  using _stationary_type =
    bool;
  _stationary_type stationary;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__brake_pc(
    const float & _arg)
  {
    this->brake_pc = _arg;
    return *this;
  }
  Type & set__brake_torque_request(
    const float & _arg)
  {
    this->brake_torque_request = _arg;
    return *this;
  }
  Type & set__brake_torque_actual(
    const float & _arg)
  {
    this->brake_torque_actual = _arg;
    return *this;
  }
  Type & set__brake_pressure(
    const float & _arg)
  {
    this->brake_pressure = _arg;
    return *this;
  }
  Type & set__stationary(
    const bool & _arg)
  {
    this->stationary = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__BrakeInfoReport
    std::shared_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__BrakeInfoReport
    std::shared_ptr<dbw_fca_msgs::msg::BrakeInfoReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BrakeInfoReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->brake_pc != other.brake_pc) {
      return false;
    }
    if (this->brake_torque_request != other.brake_torque_request) {
      return false;
    }
    if (this->brake_torque_actual != other.brake_torque_actual) {
      return false;
    }
    if (this->brake_pressure != other.brake_pressure) {
      return false;
    }
    if (this->stationary != other.stationary) {
      return false;
    }
    return true;
  }
  bool operator!=(const BrakeInfoReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BrakeInfoReport_

// alias to use template instance with default allocator
using BrakeInfoReport =
  dbw_fca_msgs::msg::BrakeInfoReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_HPP_
