// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dbw_fca_msgs:msg/BrakeInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__TRAITS_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dbw_fca_msgs/msg/detail/brake_info_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace dbw_fca_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BrakeInfoReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: brake_pc
  {
    out << "brake_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_pc, out);
    out << ", ";
  }

  // member: brake_torque_request
  {
    out << "brake_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_torque_request, out);
    out << ", ";
  }

  // member: brake_torque_actual
  {
    out << "brake_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_torque_actual, out);
    out << ", ";
  }

  // member: brake_pressure
  {
    out << "brake_pressure: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_pressure, out);
    out << ", ";
  }

  // member: stationary
  {
    out << "stationary: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BrakeInfoReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: brake_pc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_pc, out);
    out << "\n";
  }

  // member: brake_torque_request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_torque_request, out);
    out << "\n";
  }

  // member: brake_torque_actual
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_torque_actual, out);
    out << "\n";
  }

  // member: brake_pressure
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake_pressure: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_pressure, out);
    out << "\n";
  }

  // member: stationary
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BrakeInfoReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dbw_fca_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dbw_fca_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dbw_fca_msgs::msg::BrakeInfoReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  dbw_fca_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dbw_fca_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dbw_fca_msgs::msg::BrakeInfoReport & msg)
{
  return dbw_fca_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dbw_fca_msgs::msg::BrakeInfoReport>()
{
  return "dbw_fca_msgs::msg::BrakeInfoReport";
}

template<>
inline const char * name<dbw_fca_msgs::msg::BrakeInfoReport>()
{
  return "dbw_fca_msgs/msg/BrakeInfoReport";
}

template<>
struct has_fixed_size<dbw_fca_msgs::msg::BrakeInfoReport>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dbw_fca_msgs::msg::BrakeInfoReport>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dbw_fca_msgs::msg::BrakeInfoReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__TRAITS_HPP_
