// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/DoorCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__DOOR_CMD__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__DOOR_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__DoorCmd __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__DoorCmd __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DoorCmd_
{
  using Type = DoorCmd_<ContainerAllocator>;

  explicit DoorCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->select = 0;
      this->action = 0;
    }
  }

  explicit DoorCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->select = 0;
      this->action = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _select_type =
    uint8_t;
  _select_type select;
  using _action_type =
    uint8_t;
  _action_type action;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__select(
    const uint8_t & _arg)
  {
    this->select = _arg;
    return *this;
  }
  Type & set__action(
    const uint8_t & _arg)
  {
    this->action = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NONE =
    0u;
  static constexpr uint8_t LEFT =
    1u;
  static constexpr uint8_t RIGHT =
    2u;
  static constexpr uint8_t TRUNK =
    3u;
  static constexpr uint8_t OPEN =
    1u;
  static constexpr uint8_t CLOSE =
    2u;

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__DoorCmd
    std::shared_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__DoorCmd
    std::shared_ptr<dbw_fca_msgs::msg::DoorCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DoorCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->select != other.select) {
      return false;
    }
    if (this->action != other.action) {
      return false;
    }
    return true;
  }
  bool operator!=(const DoorCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DoorCmd_

// alias to use template instance with default allocator
using DoorCmd =
  dbw_fca_msgs::msg::DoorCmd_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::LEFT;
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::RIGHT;
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::TRUNK;
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::OPEN;
template<typename ContainerAllocator>
constexpr uint8_t DoorCmd_<ContainerAllocator>::CLOSE;

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__DOOR_CMD__STRUCT_HPP_
