// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/Misc2Report.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'ft_drv_temp'
// Member 'ft_psg_temp'
#include "dbw_fca_msgs/msg/detail/front_temp__struct.hpp"
// Member 'ft_fan_speed'
#include "dbw_fca_msgs/msg/detail/front_fan_speed__struct.hpp"
// Member 'vent_mode'
#include "dbw_fca_msgs/msg/detail/vent_mode__struct.hpp"
// Member 'fl_heated_seat'
// Member 'fl_vented_seat'
// Member 'fr_heated_seat'
// Member 'fr_vented_seat'
#include "dbw_fca_msgs/msg/detail/hvac_seat__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__Misc2Report __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__Misc2Report __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Misc2Report_
{
  using Type = Misc2Report_<ContainerAllocator>;

  explicit Misc2Report_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    ft_drv_temp(_init),
    ft_psg_temp(_init),
    ft_fan_speed(_init),
    vent_mode(_init),
    fl_heated_seat(_init),
    fl_vented_seat(_init),
    fr_heated_seat(_init),
    fr_vented_seat(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_ac = false;
      this->ac = false;
      this->ft_hvac = false;
      this->auto_md = false;
      this->recirc = false;
      this->sync = false;
      this->r_defr = false;
      this->f_defr = false;
      this->heated_steering_wheel = false;
    }
  }

  explicit Misc2Report_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    ft_drv_temp(_alloc, _init),
    ft_psg_temp(_alloc, _init),
    ft_fan_speed(_alloc, _init),
    vent_mode(_alloc, _init),
    fl_heated_seat(_alloc, _init),
    fl_vented_seat(_alloc, _init),
    fr_heated_seat(_alloc, _init),
    fr_vented_seat(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_ac = false;
      this->ac = false;
      this->ft_hvac = false;
      this->auto_md = false;
      this->recirc = false;
      this->sync = false;
      this->r_defr = false;
      this->f_defr = false;
      this->heated_steering_wheel = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _ft_drv_temp_type =
    dbw_fca_msgs::msg::FrontTemp_<ContainerAllocator>;
  _ft_drv_temp_type ft_drv_temp;
  using _ft_psg_temp_type =
    dbw_fca_msgs::msg::FrontTemp_<ContainerAllocator>;
  _ft_psg_temp_type ft_psg_temp;
  using _ft_fan_speed_type =
    dbw_fca_msgs::msg::FrontFanSpeed_<ContainerAllocator>;
  _ft_fan_speed_type ft_fan_speed;
  using _max_ac_type =
    bool;
  _max_ac_type max_ac;
  using _ac_type =
    bool;
  _ac_type ac;
  using _ft_hvac_type =
    bool;
  _ft_hvac_type ft_hvac;
  using _auto_md_type =
    bool;
  _auto_md_type auto_md;
  using _recirc_type =
    bool;
  _recirc_type recirc;
  using _sync_type =
    bool;
  _sync_type sync;
  using _r_defr_type =
    bool;
  _r_defr_type r_defr;
  using _f_defr_type =
    bool;
  _f_defr_type f_defr;
  using _vent_mode_type =
    dbw_fca_msgs::msg::VentMode_<ContainerAllocator>;
  _vent_mode_type vent_mode;
  using _heated_steering_wheel_type =
    bool;
  _heated_steering_wheel_type heated_steering_wheel;
  using _fl_heated_seat_type =
    dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator>;
  _fl_heated_seat_type fl_heated_seat;
  using _fl_vented_seat_type =
    dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator>;
  _fl_vented_seat_type fl_vented_seat;
  using _fr_heated_seat_type =
    dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator>;
  _fr_heated_seat_type fr_heated_seat;
  using _fr_vented_seat_type =
    dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator>;
  _fr_vented_seat_type fr_vented_seat;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__ft_drv_temp(
    const dbw_fca_msgs::msg::FrontTemp_<ContainerAllocator> & _arg)
  {
    this->ft_drv_temp = _arg;
    return *this;
  }
  Type & set__ft_psg_temp(
    const dbw_fca_msgs::msg::FrontTemp_<ContainerAllocator> & _arg)
  {
    this->ft_psg_temp = _arg;
    return *this;
  }
  Type & set__ft_fan_speed(
    const dbw_fca_msgs::msg::FrontFanSpeed_<ContainerAllocator> & _arg)
  {
    this->ft_fan_speed = _arg;
    return *this;
  }
  Type & set__max_ac(
    const bool & _arg)
  {
    this->max_ac = _arg;
    return *this;
  }
  Type & set__ac(
    const bool & _arg)
  {
    this->ac = _arg;
    return *this;
  }
  Type & set__ft_hvac(
    const bool & _arg)
  {
    this->ft_hvac = _arg;
    return *this;
  }
  Type & set__auto_md(
    const bool & _arg)
  {
    this->auto_md = _arg;
    return *this;
  }
  Type & set__recirc(
    const bool & _arg)
  {
    this->recirc = _arg;
    return *this;
  }
  Type & set__sync(
    const bool & _arg)
  {
    this->sync = _arg;
    return *this;
  }
  Type & set__r_defr(
    const bool & _arg)
  {
    this->r_defr = _arg;
    return *this;
  }
  Type & set__f_defr(
    const bool & _arg)
  {
    this->f_defr = _arg;
    return *this;
  }
  Type & set__vent_mode(
    const dbw_fca_msgs::msg::VentMode_<ContainerAllocator> & _arg)
  {
    this->vent_mode = _arg;
    return *this;
  }
  Type & set__heated_steering_wheel(
    const bool & _arg)
  {
    this->heated_steering_wheel = _arg;
    return *this;
  }
  Type & set__fl_heated_seat(
    const dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator> & _arg)
  {
    this->fl_heated_seat = _arg;
    return *this;
  }
  Type & set__fl_vented_seat(
    const dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator> & _arg)
  {
    this->fl_vented_seat = _arg;
    return *this;
  }
  Type & set__fr_heated_seat(
    const dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator> & _arg)
  {
    this->fr_heated_seat = _arg;
    return *this;
  }
  Type & set__fr_vented_seat(
    const dbw_fca_msgs::msg::HvacSeat_<ContainerAllocator> & _arg)
  {
    this->fr_vented_seat = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__Misc2Report
    std::shared_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__Misc2Report
    std::shared_ptr<dbw_fca_msgs::msg::Misc2Report_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Misc2Report_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->ft_drv_temp != other.ft_drv_temp) {
      return false;
    }
    if (this->ft_psg_temp != other.ft_psg_temp) {
      return false;
    }
    if (this->ft_fan_speed != other.ft_fan_speed) {
      return false;
    }
    if (this->max_ac != other.max_ac) {
      return false;
    }
    if (this->ac != other.ac) {
      return false;
    }
    if (this->ft_hvac != other.ft_hvac) {
      return false;
    }
    if (this->auto_md != other.auto_md) {
      return false;
    }
    if (this->recirc != other.recirc) {
      return false;
    }
    if (this->sync != other.sync) {
      return false;
    }
    if (this->r_defr != other.r_defr) {
      return false;
    }
    if (this->f_defr != other.f_defr) {
      return false;
    }
    if (this->vent_mode != other.vent_mode) {
      return false;
    }
    if (this->heated_steering_wheel != other.heated_steering_wheel) {
      return false;
    }
    if (this->fl_heated_seat != other.fl_heated_seat) {
      return false;
    }
    if (this->fl_vented_seat != other.fl_vented_seat) {
      return false;
    }
    if (this->fr_heated_seat != other.fr_heated_seat) {
      return false;
    }
    if (this->fr_vented_seat != other.fr_vented_seat) {
      return false;
    }
    return true;
  }
  bool operator!=(const Misc2Report_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Misc2Report_

// alias to use template instance with default allocator
using Misc2Report =
  dbw_fca_msgs::msg::Misc2Report_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC2_REPORT__STRUCT_HPP_
