// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/misc_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `cmd`
#include "dbw_fca_msgs/msg/detail/turn_signal__functions.h"
// Member `door`
#include "dbw_fca_msgs/msg/detail/door_cmd__functions.h"
// Member `ft_drv_temp`
// Member `ft_psg_temp`
#include "dbw_fca_msgs/msg/detail/front_temp__functions.h"
// Member `ft_fan_speed`
#include "dbw_fca_msgs/msg/detail/front_fan_speed__functions.h"
// Member `max_ac`
// Member `ac`
// Member `ft_hvac`
// Member `auto_md`
// Member `recirc`
// Member `sync`
// Member `r_defr`
// Member `f_defr`
// Member `heated_steering_wheel`
#include "dbw_fca_msgs/msg/detail/hvac_button_cmd__functions.h"
// Member `vent_mode`
#include "dbw_fca_msgs/msg/detail/vent_mode__functions.h"
// Member `fl_heated_seat`
// Member `fl_vented_seat`
// Member `fr_heated_seat`
// Member `fr_vented_seat`
#include "dbw_fca_msgs/msg/detail/hvac_seat__functions.h"

bool
dbw_fca_msgs__msg__MiscCmd__init(dbw_fca_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // cmd
  if (!dbw_fca_msgs__msg__TurnSignal__init(&msg->cmd)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // door
  if (!dbw_fca_msgs__msg__DoorCmd__init(&msg->door)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // ft_drv_temp
  if (!dbw_fca_msgs__msg__FrontTemp__init(&msg->ft_drv_temp)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // ft_psg_temp
  if (!dbw_fca_msgs__msg__FrontTemp__init(&msg->ft_psg_temp)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // ft_fan_speed
  if (!dbw_fca_msgs__msg__FrontFanSpeed__init(&msg->ft_fan_speed)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // max_ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->max_ac)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->ac)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // ft_hvac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->ft_hvac)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // auto_md
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->auto_md)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // recirc
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->recirc)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // sync
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->sync)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // r_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->r_defr)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // f_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->f_defr)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // vent_mode
  if (!dbw_fca_msgs__msg__VentMode__init(&msg->vent_mode)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // heated_steering_wheel
  if (!dbw_fca_msgs__msg__HvacButtonCmd__init(&msg->heated_steering_wheel)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // fl_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fl_heated_seat)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // fl_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fl_vented_seat)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // fr_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fr_heated_seat)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // fr_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fr_vented_seat)) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  return true;
}

void
dbw_fca_msgs__msg__MiscCmd__fini(dbw_fca_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // cmd
  dbw_fca_msgs__msg__TurnSignal__fini(&msg->cmd);
  // door
  dbw_fca_msgs__msg__DoorCmd__fini(&msg->door);
  // ft_drv_temp
  dbw_fca_msgs__msg__FrontTemp__fini(&msg->ft_drv_temp);
  // ft_psg_temp
  dbw_fca_msgs__msg__FrontTemp__fini(&msg->ft_psg_temp);
  // ft_fan_speed
  dbw_fca_msgs__msg__FrontFanSpeed__fini(&msg->ft_fan_speed);
  // max_ac
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->max_ac);
  // ac
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->ac);
  // ft_hvac
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->ft_hvac);
  // auto_md
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->auto_md);
  // recirc
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->recirc);
  // sync
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->sync);
  // r_defr
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->r_defr);
  // f_defr
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->f_defr);
  // vent_mode
  dbw_fca_msgs__msg__VentMode__fini(&msg->vent_mode);
  // heated_steering_wheel
  dbw_fca_msgs__msg__HvacButtonCmd__fini(&msg->heated_steering_wheel);
  // fl_heated_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fl_heated_seat);
  // fl_vented_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fl_vented_seat);
  // fr_heated_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fr_heated_seat);
  // fr_vented_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fr_vented_seat);
}

bool
dbw_fca_msgs__msg__MiscCmd__are_equal(const dbw_fca_msgs__msg__MiscCmd * lhs, const dbw_fca_msgs__msg__MiscCmd * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // cmd
  if (!dbw_fca_msgs__msg__TurnSignal__are_equal(
      &(lhs->cmd), &(rhs->cmd)))
  {
    return false;
  }
  // door
  if (!dbw_fca_msgs__msg__DoorCmd__are_equal(
      &(lhs->door), &(rhs->door)))
  {
    return false;
  }
  // ft_drv_temp
  if (!dbw_fca_msgs__msg__FrontTemp__are_equal(
      &(lhs->ft_drv_temp), &(rhs->ft_drv_temp)))
  {
    return false;
  }
  // ft_psg_temp
  if (!dbw_fca_msgs__msg__FrontTemp__are_equal(
      &(lhs->ft_psg_temp), &(rhs->ft_psg_temp)))
  {
    return false;
  }
  // ft_fan_speed
  if (!dbw_fca_msgs__msg__FrontFanSpeed__are_equal(
      &(lhs->ft_fan_speed), &(rhs->ft_fan_speed)))
  {
    return false;
  }
  // max_ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->max_ac), &(rhs->max_ac)))
  {
    return false;
  }
  // ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->ac), &(rhs->ac)))
  {
    return false;
  }
  // ft_hvac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->ft_hvac), &(rhs->ft_hvac)))
  {
    return false;
  }
  // auto_md
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->auto_md), &(rhs->auto_md)))
  {
    return false;
  }
  // recirc
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->recirc), &(rhs->recirc)))
  {
    return false;
  }
  // sync
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->sync), &(rhs->sync)))
  {
    return false;
  }
  // r_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->r_defr), &(rhs->r_defr)))
  {
    return false;
  }
  // f_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->f_defr), &(rhs->f_defr)))
  {
    return false;
  }
  // vent_mode
  if (!dbw_fca_msgs__msg__VentMode__are_equal(
      &(lhs->vent_mode), &(rhs->vent_mode)))
  {
    return false;
  }
  // heated_steering_wheel
  if (!dbw_fca_msgs__msg__HvacButtonCmd__are_equal(
      &(lhs->heated_steering_wheel), &(rhs->heated_steering_wheel)))
  {
    return false;
  }
  // fl_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__are_equal(
      &(lhs->fl_heated_seat), &(rhs->fl_heated_seat)))
  {
    return false;
  }
  // fl_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__are_equal(
      &(lhs->fl_vented_seat), &(rhs->fl_vented_seat)))
  {
    return false;
  }
  // fr_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__are_equal(
      &(lhs->fr_heated_seat), &(rhs->fr_heated_seat)))
  {
    return false;
  }
  // fr_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__are_equal(
      &(lhs->fr_vented_seat), &(rhs->fr_vented_seat)))
  {
    return false;
  }
  return true;
}

bool
dbw_fca_msgs__msg__MiscCmd__copy(
  const dbw_fca_msgs__msg__MiscCmd * input,
  dbw_fca_msgs__msg__MiscCmd * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // cmd
  if (!dbw_fca_msgs__msg__TurnSignal__copy(
      &(input->cmd), &(output->cmd)))
  {
    return false;
  }
  // door
  if (!dbw_fca_msgs__msg__DoorCmd__copy(
      &(input->door), &(output->door)))
  {
    return false;
  }
  // ft_drv_temp
  if (!dbw_fca_msgs__msg__FrontTemp__copy(
      &(input->ft_drv_temp), &(output->ft_drv_temp)))
  {
    return false;
  }
  // ft_psg_temp
  if (!dbw_fca_msgs__msg__FrontTemp__copy(
      &(input->ft_psg_temp), &(output->ft_psg_temp)))
  {
    return false;
  }
  // ft_fan_speed
  if (!dbw_fca_msgs__msg__FrontFanSpeed__copy(
      &(input->ft_fan_speed), &(output->ft_fan_speed)))
  {
    return false;
  }
  // max_ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->max_ac), &(output->max_ac)))
  {
    return false;
  }
  // ac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->ac), &(output->ac)))
  {
    return false;
  }
  // ft_hvac
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->ft_hvac), &(output->ft_hvac)))
  {
    return false;
  }
  // auto_md
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->auto_md), &(output->auto_md)))
  {
    return false;
  }
  // recirc
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->recirc), &(output->recirc)))
  {
    return false;
  }
  // sync
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->sync), &(output->sync)))
  {
    return false;
  }
  // r_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->r_defr), &(output->r_defr)))
  {
    return false;
  }
  // f_defr
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->f_defr), &(output->f_defr)))
  {
    return false;
  }
  // vent_mode
  if (!dbw_fca_msgs__msg__VentMode__copy(
      &(input->vent_mode), &(output->vent_mode)))
  {
    return false;
  }
  // heated_steering_wheel
  if (!dbw_fca_msgs__msg__HvacButtonCmd__copy(
      &(input->heated_steering_wheel), &(output->heated_steering_wheel)))
  {
    return false;
  }
  // fl_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__copy(
      &(input->fl_heated_seat), &(output->fl_heated_seat)))
  {
    return false;
  }
  // fl_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__copy(
      &(input->fl_vented_seat), &(output->fl_vented_seat)))
  {
    return false;
  }
  // fr_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__copy(
      &(input->fr_heated_seat), &(output->fr_heated_seat)))
  {
    return false;
  }
  // fr_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__copy(
      &(input->fr_vented_seat), &(output->fr_vented_seat)))
  {
    return false;
  }
  return true;
}

dbw_fca_msgs__msg__MiscCmd *
dbw_fca_msgs__msg__MiscCmd__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__MiscCmd * msg = (dbw_fca_msgs__msg__MiscCmd *)allocator.allocate(sizeof(dbw_fca_msgs__msg__MiscCmd), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__MiscCmd));
  bool success = dbw_fca_msgs__msg__MiscCmd__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__MiscCmd__destroy(dbw_fca_msgs__msg__MiscCmd * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dbw_fca_msgs__msg__MiscCmd__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dbw_fca_msgs__msg__MiscCmd__Sequence__init(dbw_fca_msgs__msg__MiscCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__MiscCmd * data = NULL;

  if (size) {
    data = (dbw_fca_msgs__msg__MiscCmd *)allocator.zero_allocate(size, sizeof(dbw_fca_msgs__msg__MiscCmd), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__MiscCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__MiscCmd__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__MiscCmd__Sequence__fini(dbw_fca_msgs__msg__MiscCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__MiscCmd__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__MiscCmd__Sequence *
dbw_fca_msgs__msg__MiscCmd__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dbw_fca_msgs__msg__MiscCmd__Sequence * array = (dbw_fca_msgs__msg__MiscCmd__Sequence *)allocator.allocate(sizeof(dbw_fca_msgs__msg__MiscCmd__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__MiscCmd__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__MiscCmd__Sequence__destroy(dbw_fca_msgs__msg__MiscCmd__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dbw_fca_msgs__msg__MiscCmd__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dbw_fca_msgs__msg__MiscCmd__Sequence__are_equal(const dbw_fca_msgs__msg__MiscCmd__Sequence * lhs, const dbw_fca_msgs__msg__MiscCmd__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dbw_fca_msgs__msg__MiscCmd__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dbw_fca_msgs__msg__MiscCmd__Sequence__copy(
  const dbw_fca_msgs__msg__MiscCmd__Sequence * input,
  dbw_fca_msgs__msg__MiscCmd__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dbw_fca_msgs__msg__MiscCmd);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dbw_fca_msgs__msg__MiscCmd * data =
      (dbw_fca_msgs__msg__MiscCmd *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dbw_fca_msgs__msg__MiscCmd__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dbw_fca_msgs__msg__MiscCmd__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dbw_fca_msgs__msg__MiscCmd__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
