// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dbw_fca_msgs:msg/ThrottleCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dbw_fca_msgs__msg__ThrottleCmd __attribute__((deprecated))
#else
# define DEPRECATED__dbw_fca_msgs__msg__ThrottleCmd __declspec(deprecated)
#endif

namespace dbw_fca_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ThrottleCmd_
{
  using Type = ThrottleCmd_<ContainerAllocator>;

  explicit ThrottleCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pedal_cmd = 0.0f;
      this->pedal_cmd_type = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
      this->count = 0;
    }
  }

  explicit ThrottleCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pedal_cmd = 0.0f;
      this->pedal_cmd_type = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
      this->count = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _pedal_cmd_type =
    float;
  _pedal_cmd_type pedal_cmd;
  using _pedal_cmd_type_type =
    uint8_t;
  _pedal_cmd_type_type pedal_cmd_type;
  using _enable_type =
    bool;
  _enable_type enable;
  using _clear_type =
    bool;
  _clear_type clear;
  using _ignore_type =
    bool;
  _ignore_type ignore;
  using _count_type =
    uint8_t;
  _count_type count;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__pedal_cmd(
    const float & _arg)
  {
    this->pedal_cmd = _arg;
    return *this;
  }
  Type & set__pedal_cmd_type(
    const uint8_t & _arg)
  {
    this->pedal_cmd_type = _arg;
    return *this;
  }
  Type & set__enable(
    const bool & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__clear(
    const bool & _arg)
  {
    this->clear = _arg;
    return *this;
  }
  Type & set__ignore(
    const bool & _arg)
  {
    this->ignore = _arg;
    return *this;
  }
  Type & set__count(
    const uint8_t & _arg)
  {
    this->count = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CMD_NONE =
    0u;
  static constexpr uint8_t CMD_PEDAL =
    1u;
  static constexpr uint8_t CMD_PERCENT =
    2u;

  // pointer types
  using RawPtr =
    dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dbw_fca_msgs__msg__ThrottleCmd
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dbw_fca_msgs__msg__ThrottleCmd
    std::shared_ptr<dbw_fca_msgs::msg::ThrottleCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ThrottleCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->pedal_cmd != other.pedal_cmd) {
      return false;
    }
    if (this->pedal_cmd_type != other.pedal_cmd_type) {
      return false;
    }
    if (this->enable != other.enable) {
      return false;
    }
    if (this->clear != other.clear) {
      return false;
    }
    if (this->ignore != other.ignore) {
      return false;
    }
    if (this->count != other.count) {
      return false;
    }
    return true;
  }
  bool operator!=(const ThrottleCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ThrottleCmd_

// alias to use template instance with default allocator
using ThrottleCmd =
  dbw_fca_msgs::msg::ThrottleCmd_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t ThrottleCmd_<ContainerAllocator>::CMD_NONE;
template<typename ContainerAllocator>
constexpr uint8_t ThrottleCmd_<ContainerAllocator>::CMD_PEDAL;
template<typename ContainerAllocator>
constexpr uint8_t ThrottleCmd_<ContainerAllocator>::CMD_PERCENT;

}  // namespace msg

}  // namespace dbw_fca_msgs

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_HPP_
