// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dbw_fca_msgs:msg/ThrottleInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__TRAITS_HPP_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dbw_fca_msgs/msg/detail/throttle_info_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'gear_num'
#include "dbw_fca_msgs/msg/detail/gear_num__traits.hpp"
// Member 'ignition'
#include "dbw_fca_msgs/msg/detail/ignition__traits.hpp"

namespace dbw_fca_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ThrottleInfoReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: throttle_pc
  {
    out << "throttle_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.throttle_pc, out);
    out << ", ";
  }

  // member: axle_torque
  {
    out << "axle_torque: ";
    rosidl_generator_traits::value_to_yaml(msg.axle_torque, out);
    out << ", ";
  }

  // member: gear_num
  {
    out << "gear_num: ";
    to_flow_style_yaml(msg.gear_num, out);
    out << ", ";
  }

  // member: ignition
  {
    out << "ignition: ";
    to_flow_style_yaml(msg.ignition, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ThrottleInfoReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: throttle_pc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "throttle_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.throttle_pc, out);
    out << "\n";
  }

  // member: axle_torque
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "axle_torque: ";
    rosidl_generator_traits::value_to_yaml(msg.axle_torque, out);
    out << "\n";
  }

  // member: gear_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gear_num:\n";
    to_block_style_yaml(msg.gear_num, out, indentation + 2);
  }

  // member: ignition
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignition:\n";
    to_block_style_yaml(msg.ignition, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ThrottleInfoReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dbw_fca_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dbw_fca_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dbw_fca_msgs::msg::ThrottleInfoReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  dbw_fca_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dbw_fca_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dbw_fca_msgs::msg::ThrottleInfoReport & msg)
{
  return dbw_fca_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dbw_fca_msgs::msg::ThrottleInfoReport>()
{
  return "dbw_fca_msgs::msg::ThrottleInfoReport";
}

template<>
inline const char * name<dbw_fca_msgs::msg::ThrottleInfoReport>()
{
  return "dbw_fca_msgs/msg/ThrottleInfoReport";
}

template<>
struct has_fixed_size<dbw_fca_msgs::msg::ThrottleInfoReport>
  : std::integral_constant<bool, has_fixed_size<dbw_fca_msgs::msg::GearNum>::value && has_fixed_size<dbw_fca_msgs::msg::Ignition>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dbw_fca_msgs::msg::ThrottleInfoReport>
  : std::integral_constant<bool, has_bounded_size<dbw_fca_msgs::msg::GearNum>::value && has_bounded_size<dbw_fca_msgs::msg::Ignition>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dbw_fca_msgs::msg::ThrottleInfoReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__TRAITS_HPP_
