// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/ThrottleReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'watchdog_counter'
#include "dbw_fca_msgs/msg/detail/watchdog_counter__struct.h"

/// Struct defined in msg/ThrottleReport in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__ThrottleReport
{
  std_msgs__msg__Header header;
  /// Throttle pedal
  /// Unitless, range 0.15 to 0.80
  float pedal_input;
  float pedal_cmd;
  float pedal_output;
  /// Status
  /// Enabled
  bool enabled;
  /// Driver override
  bool override;
  /// Driver activity
  bool driver;
  /// Command timeout
  bool timeout;
  /// Watchdog Counter
  dbw_fca_msgs__msg__WatchdogCounter watchdog_counter;
  bool fault_wdc;
  /// Faults
  bool fault_ch1;
  bool fault_ch2;
  bool fault_power;
} dbw_fca_msgs__msg__ThrottleReport;

// Struct for a sequence of dbw_fca_msgs__msg__ThrottleReport.
typedef struct dbw_fca_msgs__msg__ThrottleReport__Sequence
{
  dbw_fca_msgs__msg__ThrottleReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__ThrottleReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_
